Issue 20370

Summary: Q-PCD MSInteroperability-33: embedd fonts into the document
Product: gsl Reporter: christof.pintaske
Component: codeAssignee: AOO issues mailing list <issues>
Status: REOPENED --- QA Contact:
Severity: Trivial    
Priority: P3 CC: bettina.haberer, fracting, giuseppe.castagno, gleppert, gschintgen, ikuya, issues, jbf.faure, jlp.bugs, kozodaevroman, lohmaier, luctur, maho.nakata, mark.lindros, ooo-bugs, richlv, tora3, xslf
Version: OOo 1.0.0Keywords: oooqa, rfe_eval_ok
Target Milestone: AOO PleaseHelp   
Hardware: Other   
OS: Other OS   
Issue Type: FEATURE Latest Confirmation in: ---
Developer Difficulty: ---
Issue Depends on:    
Issue Blocks: 15611    

Description christof.pintaske 2003-09-29 18:36:22 UTC
Customer Need/Problem
presentation have to be shown as they are designed on any target system out of
the box (without having to install a separate font package)

Product Concept
Embedd Type1 and TrueType fonts and fontsubset  in a subfolder of the document.
Allow user specify the level of embedding. The embedded font is only available
for the respective document.
Comment 1 christof.pintaske 2003-09-29 18:38:29 UTC
change component to gsl
Comment 2 lutz.hoeger 2003-10-23 07:45:22 UTC
added keyword Q-PCD
Comment 3 christof.pintaske 2004-02-16 13:28:43 UTC
cp: Microsoft Office embedds fonts using MicroType Express technology licensed
from Agfa Monotype (http://www.microsoft.com/typography/TrueTypeEmbedding.mspx ,
http://www.microsoft.com/typography/fontpack/pr2.htm). We would need to license
this technology from Agfa in order to be able to use these fonts in imported MS
Office documents.

Embedding fonts in our own documents needs to pay attention to the font
embedding policiy recorded in TrueType fonts: No Embedding Allowed,
Preview&Print, Editable, and Installable. This needs to be communicated to the
user who wants to use font embedding. Most fonts seem to allow for Preview&Print.

TrueType fonts allow for subsetting, that is: storing only the glyphs/characters
that are required in the (unmodified) document. Type1 would require much more
work in this regard, however the bigger CJK fonts are mostly TrueType. 

MIB suggested to embedd the fonts in standard file format that already has a
mimetype assigned to, or is reasonably well known. Storing the font-information
itself in the document is possible without changing the fileformat.
Comment 4 christof.pintaske 2004-02-16 13:41:03 UTC
*** Issue 9953 has been marked as a duplicate of this issue. ***
Comment 5 christof.pintaske 2004-02-16 13:46:39 UTC
maho suggested to do font-metric embedding in #i15611#. This can be seen as a
0-level font embedding. It preserves document layout but does not help you with
the particular document contents. It has less legal implication. 
Comment 6 christof.pintaske 2004-02-16 13:49:09 UTC
*** Issue 15611 has been marked as a duplicate of this issue. ***
Comment 7 floeff+ooo 2004-02-16 13:55:10 UTC
You could do it as CorelDRAW does: displaying a legal warning before embedding.
Comment 8 maho.nakata 2004-03-08 01:46:46 UTC
There may be several methods to virtualize fonts:
a) support TeX font metric files (tfm)
b) support Adobe font metric files (afm)
afm files may be public domain since afm files are already included in OOo.
see #i15611 to where to find it.
one possible problem is where to find full UNICODE implimentation
of virtualized fonts. At least OOo contains basic (latin) fonts (e.g.,
Times Roman, Courier, Helvetica and its variables, oblique etc.)
and Japanese fonts (Ryumin Light and GothicBBB)
but non of others. I'll investigate what Adobe thinks.
It affects basic part of format of documents, but still we can impliment as
optional feature.





Comment 9 christof.pintaske 2004-05-25 19:35:29 UTC
retargeted to later due to time constraints
Comment 10 michael.ruess 2004-07-13 12:32:43 UTC
*** Issue 31387 has been marked as a duplicate of this issue. ***
Comment 11 christof.pintaske 2005-04-13 17:58:01 UTC
cp->ka: nice feature, especially for impress. 
Comment 12 lohmaier 2005-08-06 17:56:45 UTC
*** Issue 47234 has been marked as a duplicate of this issue. ***
Comment 13 lohmaier 2005-08-06 17:57:35 UTC
setting keywords
Comment 14 lohmaier 2005-08-06 18:00:18 UTC
*** Issue 47234 has been marked as a duplicate of this issue. ***
Comment 15 lohmaier 2005-08-06 18:01:59 UTC
*** Issue 45106 has been marked as a duplicate of this issue. ***
Comment 16 lohmaier 2005-08-06 18:05:05 UTC
*** Issue 45457 has been marked as a duplicate of this issue. ***
Comment 17 lohmaier 2005-08-06 18:18:38 UTC
*** Issue 23732 has been marked as a duplicate of this issue. ***
Comment 18 nigelenki 2005-09-21 19:19:41 UTC
This could be the cause of #54925

Embedding fonts is a nice idea.  Although it may have legal issues, this is (to
be blunt) not a concern of yours/ours/anyone's.  It is up to the creator of the
document to avoid plagerism and copyright violations.  This doesn't mean we
can't be nice and display a warning when the user asks to embed fonts; it just
means we're not the DRM police and we shouldn't be attempting to stop people
from doing it if they want.  After all, the party creating the document may be
licensed to use the font in that way, and we wouldn't want to pretend we're
trying to stop them from breaking the law.

The font metrics suggestion is interesting for finished presentations; embedding
partial fonts is also interesting for finished presentations.  Sometimes,
however, you want to work on a document you have on a USB flash drive or
something and need the full font embedded to do the work.

OpenOffice.org could potentially put icons next to open fonts, if you could find
a way to embed license information in them.  GPL fonts have been questioned as
to if they're legally dangerous (do you have to GPL your document?), PD fonts
are awesome, CC-by-sa is fine too, as well as GPL with font clause.  For the
incredibly semantic, this would alert them to which fonts were free and open and
which were locked down.  Non-iconed ones would be of unknown (and assumed
closed) licensing.
Comment 19 upscope 2006-06-17 00:05:47 UTC
I am doing a news letter that needs to be avaliable in both word and pdf 
format. I can get the correct fonts if I export it as pdf. but creating the 
word document does not save the fonts. It is the above issue.

This format has been used for years under MS Publisher, but I have no desire to 
go back to MS. Both Scribus and OpenOffice create a good PDF document but I 
need the word version also.  
Comment 20 kreawit 2006-10-19 15:37:52 UTC
Embedded fonts are very importent when archiveing documents, when collaborateing
with other people and mailing documents to preserve layout. Retreaving documents
from a backup or archive can be a nightmare if the fonts have changed or are gone. 
Comment 21 sergey_feo 2007-04-19 16:24:26 UTC
1. Sorry for my bad English :)
2. IMHO fonts embedding should be a main task for next major release of
OpenOffice. Or one of main tasks :)
3. Because of problem is very complex and difficult but also is very important -
i think a "half-solution" can be implemented for the first time. We can have an
option "attach font files to the document". It will copy all used font files
into document archive subdirectory, but will not use this files. This option can
prevent a big part of "archives restoring nightmare". Also, users in future
always will know: if they do not have some font for document - they can open the
document as usual ZIP archive and get needed fonts. Not all fonts can be
installed in all OSes, but IMHO this be better that nothing. Also, this can
soften licensions problems: we can say distribute fonts in document, but not
fully compile fonts with document. Or we can't - i am not an jurist :-)


Comment 22 luctur 2008-09-11 09:45:46 UTC
I hope this feature will never be implemented, because it would be a legal
nightmare for whatever user.

Here:

http://scripts.sil.org/cms/scripts/render_download.php?site_id=nrsi&format=file&media_id=UNESCO_Font_Lic_PDF&filename=UNESCO_Font_Lic_PDF.pdf

you can find a "Font copyright for dummies" document made by an independent
organization like UNESCO that explains in few words how difficult would be,
legally speaking, to manage documents with proprietary fonts embedded.

There would be issues not only for the original creator of the document, but for
the authors of *derivative* works too, if they won't know which font is embedded
under which license.

In the professional world of press, publishing, journalism and in any case in
which a document will have derivative elaborations, such a feature may cause
unknown liabilities for breaching of font licensing terms both for the original
author and other people/organization who will manage a specific document.

And, IMVHO, a warning window for the original author that embeds fonts isn't
enough to avoid problems for other people who use the document for other (large
scale, on line, administrative, commercial) purposes.

Any analysis about the implementation of this feature should include more cons
than pros.
Comment 23 clippka 2008-09-11 10:47:39 UTC
Due to the long inactivity of this issue and valid concerns of legal
implecations I will close this issue
Comment 24 clippka 2008-09-11 10:48:50 UTC
closing
Comment 25 toshio 2008-09-11 13:39:06 UTC
what is happened? You must reopen issue! take in mind legality or non-legality
does not apply to OpenOffice, but only to end user. you know that some people
sold by micro$oft can post interested comments in order to stop OpenOffice
progress. so, font embedding is very important for effective interoperability,
otherwise people still using Word. Do you want this? people still using
micro$oft Word instead of OpenOffice? it is not legality issue. micro$oft word
embed usually fonts, so embedding is fully legal, why, then, people using
OpenOffice must have lesser features? a kind of masochism?
Comment 26 luctur 2008-09-11 13:47:12 UTC
Embedding fonts is legal if you have rights to do so. Please read "Adobe versus
ICT" U.S. sentence before commenting further.

Comment 27 luctur 2008-09-11 13:48:31 UTC
Ops... "Adobe versus ITC". Sorry for the mistake. :)
Comment 28 armandillo 2008-09-11 14:13:49 UTC
interesting question: point of view on legality is wrong: I explain why: in
fact, OpenOffice, implementing a font embedding feature, does not breaks any law
or infringes copyright, because it does not embed nothing, only makes user able
to embed. the effective embedder is end user (I agree with other poster on
this). if end user breaks laws or copyright, He/She breaks, not openoffice,
because I can have need of embedding an opensource (GPL licensed) font, so, as
end user, I don't break any kind of law or copyright.
Comment 29 tange 2008-09-11 14:43:11 UTC
If we feel unsure about the legal status and think it will be a legal nightmare
for the normal user to embed proprietary fonts, then let us start out safe by
allowing the embedding of fonts we know are safe to embed.

Though it would not make it as easy to use as Microsoft Word, it might just
promote people to use the free fonts.

Personally I can live with a limited selection of fonts, but it is a really pain
that I cannot be guaranteed that my document looks the same when I move it to a
system, that does not have the fonts.
Comment 30 kreawit 2008-09-11 14:55:44 UTC
I agree with armandillo, its not an good idea that Openoffice tries to block the
use of embedded fonts. 

Today an enduser can embedd other copyrighted objects like pictures, sound and
copied text extracts. In these cases there is the endusers obligation to be
observant and make the right steps to follow his local copyright laws. I can't
see any differens or other problems embedding fonts with several types of
enduser licens agreements than embedding other copyrighted objects. It's not
realistic that it is the software, Openoffice, that makes those decisions for
the enduser.
Comment 31 luctur 2008-09-11 14:57:26 UTC
Again, please read Adobe vs. ITC (AGFA) sentence before further commenting.

It's exactly the same situation: Adobe had and has applications that embed 
fonts. They didn't win that trial because "effective embedder is end user", but 
because they (Adobe) had payed for rights to produce applications that embeds 
fonts.

In this issue has already been suggested to get a license from AGFA for a 
specific technology in order to get a better MS Office compatibility. If that 
solution is a viable one, it may resolve all problems.

Otherwise, if technically possible according to OpenDocument specifications, it 
would be good to enforce a *strict* respect for embedding bits included into 
fonts files.

However, even if fonts have the "Editable" or "Installable" bit set, we still 
don't know nothing about its license.

I have personally read "Cease and Desist" letters addressed to software 
developers and written for claims based on Section 1201(a) of the 1998 Digital 
Millennium Copyright Act because their software *may* be used to embed fonts 
that had the "No Embedding Allowed" bit set. And those developers used their 
software for *free* fonts embedding.

I don't say a Cease and Desist letter is like a law or a sentence. 
Nevertheless, at least, it's surely a good chance to be called before a court 
to resolve the question. Does OOo *really* need this sort of "risk"?
Comment 32 tange 2008-09-11 18:29:15 UTC
luctur: Please post a link to the sentence. I have searched for it without
finding it. I have a feeling it does not apply to any of the countries that does
not have DMCA.

From what you write, I still see it would cause no problems if OOo only allows
embedding of a specified list of fonts that are free for this purpose - even in
countries with DMCA. Thereby it may not be used for other fonts.
Comment 33 merp 2008-09-11 21:00:28 UTC
Is anyone on the OO team a lawyer or have professional legal background? I 
have contacted the kind people at EFF (Electronic Frontier Foundation) ( 
http://www.eff.org ), who do have lawyers on hand specifically to address 
these kinds of issues. I don't know if they have any better suggestions, but 
if the only reason for not implementing this CRITICAL feature is because of 
fear of legal ramifications, then it seems consulting lawyers who specialize 
in electronic intellectual property laws/rights, would be the best source to 
consult before completely giving up on some variant of an "embedded fonts" 
capability (such as the aforementioned partial functionality of somehow only 
allowing "open" fonts to be embedded). Please reconsider opening this feature 
for now, for consideration. I don't know if the EFF folks will take this on, 
or even be able to suggest any more than you have from the "Chilling Effect" 
of the "Adobe vs. ITC" and other cases. But it is certainly worth 
investigating before completely giving up on so critical a feature. This 
lacking component is a show-stopper feature for our magazine at the very 
least. And I can only imagine how many others are stuck, unable to fully 
utilize OO for similar reasons, and forced to either use MS/Adobe commercial 
products, or completely stuck because there is no alternative on their 
operating system (many of us use only Linux, BSD, Solaris, etc.), and have no 
alternative, and are being seriously impacted in trying to collaborate in the 
final stages of the zine.
Thank you all for you great work and efforts, and please do not give up on 
this feature just yet.
Comment 34 luctur 2008-09-12 08:27:24 UTC
tange: you can search also Agfa vs. Adobe [404 F. Supp. 2d 1030 (N.D. Ill.
2005)]. They sued each other several times on very similar topics. This sentence
is really more liberal and it may permit OOo to implement a font embedding
feature even in the U.S.
However, it has not prevented other corporations to start claims about the very
same question. For example, Storage Technology Corp. v. Custom Hardware
Engineering & Consulting, Ltd [No. 02-12102-RWZ, 2006 WL 1766434 (D. Mass. June
28, 2006)] and others. This is the "risk" I was talking about: unneeded trials
in a controversial law field.

Then, there are other legal concerns related to users' work. For example, a font
that has the "Allow embedding" bit set says nothing about its license.

Example: Armadillo spoke about GPLed fonts. Let's say that such a font has the
quoted above bit set and OOo embeds it into a document. If the font license
doesn't includes the "GPL font exception"

http://www.gnu.org/licenses/gpl-faq.html#FontException
http://www.fsf.org/blogs/licensing/20050425novalis (explanation of the exception
aka "ratio")

*each* work derivated from that document and is content would become GPLed. 

So: you should know if a font has been embedded into a document, what license
rules it and if the embedder applied that license in the right way!

And what about if you duplicate the document and then release your own copy
under Creative Commons or a proprietary copyright since *in the content* is
written that you can apply such licenses?

Is it a legal nightmare, isn't it?

Same considerations can be done for proprietary fonts EULA and your own documents.

Sincerely, embedding fonts is a *risky* activity, legally speaking. You should
have a windows that pops up every time someone opens a document and warns "A
font has been embedded under license XYZ"...

And trials about fonts embedding are not so uncommon. And even if you win them,
they have a *cost*, in time and money. Recently, even in my country, Italy,
Business Software Association started a campaign against "font piracy".
Implementing this feature would make me wonder if I'm a "pirate" just because
someone, somewhere, has embedded a font in a document that I have to edit. IMO,
there would be too much troubles.

Making this feature an option for those professionals who really need it? I may
agree on this, but it should be a very detailed and legal-bullet-proof one for
the rest of the user world.
Comment 35 insount 2008-09-12 22:28:30 UTC
luctur: Could you explain how the font copyright situation is different from any
other copyrighted content? Should OpenOffice.org also remove support for
embedded images and even text, because they may be copyrighted and distributed
under licenses that exposes people to infringement claims? Should you have a
windows that pops up every time someone opens a document and warns "An image
has been embedded under license XYZ"?
Comment 36 luctur 2008-09-13 07:43:10 UTC
insount: the difference between an embedded image and a embedded font is that, 
usually, the former is a *part* of the content, while the latter is an 
*attribute* of the content. Users pay different legal attention to these 
elements.

Technically, it's well explained in the OpenDocument specifications and it's 
also a logical valid argument, in this case.

Then, there are also documents, i.e. trade logos or artistic drawings, in which 
the *visual representation* of a font - not the font itself - may be part of 
the content. In those cases, the legal concerns are completely different and 
less important for the average users, since they should have or have had a 
professional legal support that explains what can or cannot do with their 
logo's "representation".

I have no power to block or unblock this issue, but i'd prefer not to add 
another element for which I have to check the license, especially if that 
addition is automatically done by a software application and it may be not 
clearly evident for the embedder or other users of a document(read: me)
Comment 37 sergey_feo 2008-09-13 20:28:01 UTC
(sorry for my bad english)

Here we can see an exellent example of how copyrights can inhibite technical
progress :-)

Please note that fonts that we usually calls "free" can be not so free as we
think. For example, user of "liberation" fonts v1.0-1 must be located out of
Cuba. Hyperbolic variant: is the font that can be used legally only at Moon free
or not free?

Other interesting thing is from "dejavu" fonts v2.24: "The above copyright and
trademark notices and this permission notice
shall be included in all copies of one or more of the Font Software
typefaces." Does it mean that text of license of this fonts must be included in
document that has this fonts in embedded form?

The next thing. Many of people here say about "legal nightmare" that we will
have if embedding fonts in OpenOffice documents will be implemented. But now
OpenOffice can export documents to PDF. I do not know technical details, but it
looks like resulting PDFs have embedded fonts. And AFAIK editing of PDFs feature
will be implemented in future. Please note that OpenOffice does not show any
warnings about legal problems when create PDFs.  

By the way. This is question to all people here who want OpenOffice without
fonts embedding but want to use free software and free fonts. How do you send
you documents to Windows users? 
I have a problem with this now. When I give an odt document to my colleagues -
Windows users for editing, I give them also a distributive of OpenOffice +
archive with fonts on USB flash drive + instructions how to install this fonts
into Windows. The solution of this problem is using only "liberation" fonts
family. This fonts has same metric that main Windows fonts and documents can be
opened properly on Windows even if "liberation" fonts is not installed. But
"liberation" family have no font with "times"-like view ("Liberation Serif" have
same metric that "Times New Roman"), so limitation to use only this font family
is very restrictive.  

The other problem I have is broken font that have different metric in different
formats. Document that using this font in Type-1 format on GNU/Linux can not be
transfered to Windows where this font is in TrueType format because an interval
between text lines is different :-(

To luctur: 
> However, even if fonts have the "Editable" or "Installable" bit set we still
don't know nothing about its license.
What about a new font format with embedded license? Or about petitions to
current font formats authors with ask to add obligatory license text to font
files in this formats?
Comment 38 luctur 2008-09-14 09:05:18 UTC
sergey_feo: indeed, PDF font embedding made by OOo is another strictly related 
issue that is open since years. Just check this OOo issue tracker for "PDF 
fonts" or similar query string and you'll find people who want an option in 
order to *not* embed fonts into their PDF documents or to change what is 
embedded. The arguments in favor or against it are the same ones we are 
discussing here.

However, in OOo PDF there is also a *huge* problem with font substitution: you 
believe to have included a specific font while OOo, really, has embedded Times 
New Roman instead of Times, Arial instead of Helvetica or, even, fonts that 
were used with a text style that is no longer utilized in the main content or 
that belong to the same font family of a font that has not the "embedding" bit 
set. Everything without warning from OOo, at least for the time being:

http://qa.openoffice.org/issues/show_bug.cgi?id=72910

Sometimes, you discovers these glitches because the PDF size is strange or 
grows out of control. Sometimes, you don't realize what is happening and simply 
go ahead with your work. Maybe, breaching the font license.

Then, about font files that directly include license text: that is the right 
approach. Nevertheless, there should be a technical mean that shows those terms 
and clauses to the application end user in a human readable way.

For example, GPL license text says: "An interactive user interface 
displays “Appropriate Legal Notices” to the extent that it includes a 
convenient and prominently visible feature that (1) displays an appropriate 
copyright notice, and (2) tells the user that there is no warranty for the work 
(except to the extent that warranties are provided), that licensees may convey 
the work under this License, and how to view a copy of this License. If the 
interface presents a list of user commands or options, such as a menu, a 
prominent item in the list meets this criterion."

I know this legal "stuff" for fonts is extremely annoying and most people 
doesn't care at all about it until a lawyer - or worse, an public attorney in 
those countries in which software piracy is a criminal law affair - contacts 
them.

Finally, it would be interesting to know *how* a font could be embedded by 
respecting OpenDocument 1.2 specification. I'm not a developer and I'm just 
curious.
Comment 39 sergey_feo 2008-09-14 18:50:59 UTC
luctur:

Again, sorry for my English :-)

I was really surprized by problem with font substitution in PDF export. 
If licensing problems is so big at this stage - we can prolong this line and
then next question will be: is flag "Print to file" in print dialog legal or
illegal?..

> Then, about font files that directly include license text: that is the right 
approach. 

How do you think: what is better: private e-mailing to font formats developers
with this request first or organizing community petitions without more ado? :-)
I can try this if I will have a time.

> Finally, it would be interesting to know *how* a font could be embedded by 
respecting OpenDocument 1.2 specification. I'm not a developer and I'm just 
curious.

I do not know it for now also and just have hope that specification developers
foresaw this. But even if fonts embedding was not foreseen by OpenDocument
specification - its developers always can see how this feature realized in M$
OpenXML. I believe it supports font embedding because of old .doc formats did
this. This can be a way how OpenXML can be helpful for community :-)
Comment 40 luctur 2008-09-15 08:44:16 UTC
I'll resume what has been said in this issue, just for simplicity:

1) many people (82 votes for this issues) have a legitimate need for the font 
embedding feature;
2) in the Agfa vs Adobe legal saga we've learned that a software producer *can* 
add this option without violating DMCA, but that fact has not prevented other 
corporations to start exactly the same claims before a court;
3) unwanted embedding of fonts may cause to the end users serious troubles, 
like with GPL fonts without GNU font exception. A really good GUI that warns 
them is really needed if the feature is implemented;
3) the tsType bits (those that say to 3rd party application what to do with a 
font) doesn't say nothing about the real license of a font, that can be very 
complex;
4) I and others doesn't know if the font embedding is possible according to 
OpenDocument 1.2 specification.

My suggestion is to enlarge this this discussion by posting to 
discuss@openoffice.org and users@openoffice.org (the former is better than the 
latter one) so that we can know whether:

a) OpenDocument 1.2 or future specification can be used for embedding software;
b) Sun considers font embedding in OOo a safe activity for itself;
c) font embedding can be implemented with a simple and safe interface that 
prevents glitches (both legal and practical) like those present in PDF export.

I think it's very important to know whether the feature is feasible according 
to ODF 1.2 so that we know the real problem is a legal one only.

Whoever is interested in this issue can start the discussion in the mailing 
lists, just let us know so that we can join it. Without the attention of the 
community at large, I doubt this issue will never be reopened.

But, please, in such discussion avoid comments like: "you know that some people 
sold by micro$oft can post interested comments in order to stop OpenOffice 
progress", because it would imply an underestimation, someone may say an 
insult, of the intelligence and independence of many people who have seriously 
contributed to this issue log.
Comment 41 sergey_feo 2008-10-26 17:03:19 UTC
In some posts above we talk that font files that directly include license text
is a good thing.

I discover :-) that TTF font files can carry full license text (by non-standart
way) and this is no necessarily to ask TTF format developers to add license
fields into TTF specification.
This is about Bitstream Vera Fonts (http://www.gnome.org/fonts/): 

"Note that the Vera copyright is incorporated in the fonts themselves.  The
License field in the fonts contains the copyright license as it appears below.
The TrueType copyright field is not large enough to contain the full license, so
the license is incorporated (as you might think if you thought about it) into
the license field, which unfortunately can be obscure to find.  (In pfaedit,
see: Element->Font Info->TTFNames->License)."

The technical details can be found here:
http://developer.apple.com/textfonts/TTRefMan/RM06/Chap6name.html (table 42
"Name Identifiers", NameID codes 0, 13 and 14). We can see that fonts developers
use "License" field for license text but this field "should be written in plain
language, not legalese" according to specification because of "Copiright notice"
field is too small. Future OpenOffice should know this trick.

I surmise that TTF can have other formats.

The situation with Type 1 fonts is not so good and far more compex.
I found 3 file types related to Type 1 on my system: .afm, .pfa and .pfb.
This was found in X11 font directory. It is possible that some other formats
exists in CUPS, ghostscript and xpdf directories.

The specification for .afm is here:
http://www.adobe.com/devnet/font/pdfs/5004.AFM_Spec.pdf

It discribes only optional "Notice" field (on page 26) that can contain "Font
name trademark or copyright notice".
I view real .afm files on my machine and see short copyright info in "Comment"
and "Notice" fields.

I am not sure that specification for .pfa is this:
http://partners.adobe.com/public/developer/en/font/T1_SPEC.PDF

This specification mentions "Notice" field but not describes it (at least I did
not found description). In real .pfa files I see short copyright info in comment
(starting from "%%") and in "Notice" field.

I did not found specification for .pfb format at this time.

The CCF format for Type 1 also exists, specification is:
http://partners.adobe.com/public/developer/en/font/5176.CFF.pdf

It contains "Notice" and "Copyright" fields. Earlier versions of this document
contained section 18 "Copyright and Trademark Notices" but it was removed
according changelog. I did not found description of this fields in modern
version of document.

The .pfm files also exists in nature. The document (not specification AFAIK)
describing this format is here:
http://partners.adobe.com/public/developer/en/font/5178.PFM.pdf

It describes "dfCopyright" field in table 1 "Header". This field is "60 byte
string, null padded" so it can not contain full license text but can contain
license name (for example, "GPL + font exception").

I surmise that Type 1 fonts can have yet more formats.

Some places with links to specifications:
http://en.wikipedia.org/wiki/Type_1_font
http://partners.adobe.com/public/developer/opentype/index_font_formats.html
Comment 42 sergey_feo 2008-10-26 18:29:08 UTC
This is current Open Document specification:
http://docs.oasis-open.org/office/v1.1/OS/OpenDocument-v1.1.pdf.
I did not found direct phrases like "fonts embedding" in it. Please have a look.

If Open Document specification really does not support fonts embedding - then
OpenXML can be an example:
http://www.ecma-international.org/publications/standards/Ecma-376.htm.
I found explicit phrases about fonts embedding in part 1, paragraph 15.2.12.
Comment 43 simono 2008-12-04 11:24:30 UTC
I only recently found out about this issue and I hope I can give a real world
example that would be helped by implementing something like this.

I work for a small company which gives courses in unix related subjects and we
make our own course materials. These materials take a lot of work to make and
they are long term documents, meaning they have to survive software updates and
be portable to other systems (e.g. Solaris, Linux, BSD based unix systems).
Portabilty would mean that the rendering of the page (in our case .odg files)
must be the same, regardless of which OS is providing the fonts (we currently
have an issue with Linux based X-Servers used by openoffice (2.0) clients
running on solaris, don't know yet if an update to 3.0 will fix this). 

If a document carries its fonts embedded in the document, that factor is at
least out of the way and will make the document be more self-sufficient across
platforms and time.

There may be other solutions to this problem that I'm not (yet) aware of, but
embedding the fonts would seem like an essential feature for portability of
documents.

As for the legal issues, I would place them firmly at the user's side. The user
alone is responsible for the legality of embedding the fonts, the software may,
of course, assist the user to determine the legality.

/Simon
Comment 44 eric.savary 2009-05-12 00:56:34 UTC
*** Issue 101789 has been marked as a duplicate of this issue. ***
Comment 45 armandillo 2009-05-24 16:47:15 UTC
So, OpenOfficers never will get ability to embed fonts? (a kind of hellraiserian
masochism I think)
Comment 46 merp 2009-05-27 19:29:41 UTC
I would suggest taking (at least in this case) a consideration of how 
Microsoft has addressed this concern over font embedding, basically they state 
it is the end user's responsibility to make certain they are using extra fonts 
within that font publisher's license requirements, not Microsoft's concern.
"Most fonts are licensed from their original publishers, who may place 
additional restrictions on their use and distribution. For information about 
licensing arrangements for a given font, contact the original publisher."
http://msdn.microsoft.com/en-us/library/ms533034.aspx

So, why then not consider going ahead with this very important feature with 
that approach? Why not just have a some sort of pop-up that warns the end user 
to be certain they are in compliance with the font licensing?

This really is a much needed feature.
Thanks for all the great work!
Comment 47 piyavkin 2009-07-13 18:25:50 UTC
Really needed.
Comment 48 lukeatbrowelldotinfo 2009-09-19 08:06:24 UTC
Fonts are contentious. 

Give me the option of including a copy of my TrueType Font file in my zip file (with an ODF extension), 
I've paid for the license for all the thousands of users in my company and I want an easy, platform-
independent way of shifting editable documents around inside my organisation without having to send a 
separate font installation package with each document or having to deploy these glorified clipart-glyphs 
via my IT help desk.

It is fortunate that God does not enforce his copyrights, or we'd all get nothing done!
Comment 49 bitbastler 2009-09-21 15:51:43 UTC
Really need the option of including a TrueType Font file in ODF-Files (writer,
calc, draw and impress)
Comment 50 tange 2009-09-21 16:16:41 UTC
@bitbastler

If you really need it, you should start by voting for this issue with 2 votes.
http://www.openoffice.org/issues/showvotes.cgi?voteon=20370
Comment 51 estan 2009-10-01 10:02:30 UTC
2 votes from me. This is really important. The legality of it all is up to me. 
For long term documents this is a must. Please find a way to to implement this.

Of course it shouldn't be the default behavior, but a way to explicitly embed 
certain fonts used in a document is a really important feature. A warning could 
be shown about the implications of font embedding.

I really don't see the reason for closing this bug if it's not on strong 
technical merit.
Comment 52 sergey_feo 2009-10-01 17:05:44 UTC
(excume me for my bad English)

MS Word XP suggests several symbol sets for embedding.
AFAIK user can embed:
- nothing
- all
- all without system fonts 
- all used symbols
- all used symbols without system fonts.

I suggest other variant as main for OpenOffice:
- all used Unicode blocks.

You can see what is Unicode block with "gucharmap" program under GNU/Linux for
example (you will need select "View"->"By Unicode Block" in menu).

If we will embed all symbols then document size can be too big.
If we will embed just used symbols then we will have problems with editing
document in future. For example, some rare symbol from national alphabet or
mathematical symbols that needed for editing can be lost.

Embedding Unicode blocks is compromise between document size and symbols that
will be available in the future.
Please imagine that we write some mathematical document on Russian language. It
will contain all symbols from Russian alphabet, some latin symbols, some greek
symbols, some punctuation symbols and some math symbols.
Unicode blocks for embedding can be follows:
- Basic Latin
- Latin-1 Supplement
- Greek and Coptic
- Cyrillic
- General Punctuation
- Arrows
- Mathematical Operators
- Supplemental Mathematical Operators

Document size will not be very big. If we will edit this document in the future
then it is high possibility that all symbols that we will need are already
embedded in document. For example, we will able to change "≠" to "≢" even if "≢"
was not used in original document. And we will able use "γ" even if original
document used only "α" and "β".

Comment 53 Rainer Bielefeld 2009-12-05 11:27:26 UTC
*** Issue 107456 has been marked as a duplicate of this issue. ***
Comment 54 Rainer Bielefeld 2009-12-06 09:57:11 UTC
*** Issue 107456 has been marked as a duplicate of this issue. ***
Comment 55 Rainer Bielefeld 2009-12-06 11:02:04 UTC
*** Issue 107456 has been marked as a duplicate of this issue. ***
Comment 56 gleppert 2010-01-04 23:11:34 UTC
This feature is very much needed. Please reopen it. I mostly use fonts under a
free licence. Why should these legal issues hinder my work?

If legal issues are a major problem, please consider to embed the new WOFF fonts
(a container format for TTF) that will be supported in the next version of
Firefox. They will include the type of licence of the font. Hence, OpenOffice
could WARN the user, if there is a licence problem.

Thanks 
Comment 58 stx123 2010-01-05 15:35:45 UTC
*** Issue 107456 has been marked as a duplicate of this issue. ***
Comment 59 luxx 2010-02-12 18:45:08 UTC
Most often the fonts I want to create documents with are those which are
explicitly distributable, but unfortunately have not acheived the distribution
one might hope.

There is much confusion about whether fonts can be held to a copyright anyway.
It is the font PROGRAM, FILE, or CODE that is licensed. 

According to copyright law,"Familiar symbols or designs; mere variations of
typographic ornamentation, lettering, or coloring..." are NOT eligible for
copyright protection.
http://www.copyright.gov/; click on “Copyright Basics” for more information.

I find it remarkably silly that people have been so overly cautious about
allowing the use of fonts. The intention of copyright law was never to disallow
anyone from creating THEIR OWN ORIGINAL works in the style which they choose. A
document is not a derivitive work of a font. The document displays the lettering
which cannot be copyrighted.

The problem is that when a font is embedded, the resulting file IS a derivitive
of the font (program, code). Part of the copyrighted code is included with the
document. If this code was protected so that it cannot be extracted or used on a
computer that does not have the font installed, then the document cannot be
edited on that computer, or effectively archived.

Perhaps there is a way to create an approved font list for fonts that are known
and documented to be distributable, and allow fonts on that list to be embedded.
There are some really great open fonts available these days. There would be
little need to use the fonts with restrictive licenses if we could just share
the non-restricted ones freely.

The licenses can be found. I'm suggesting the possibility that people could
sumbit fonts they want on that list with the name, filename, and links to
verifiable license documentation.
Comment 60 richlv 2010-02-25 16:34:39 UTC
can we please re-open this issue to avoid a gazillion of comments like this ? :)

i think everybody agrees that the need is there, technical means are there and 
legal issues are for users, not for the software (see any pdf exporting 
software...).

ps. yes, i voted on this issue with 2 votes :)
Comment 61 gleppert 2010-02-25 20:03:19 UTC
It seems that this is also planned for the ODF file format standard in the
future: http://tools.oasis-open.org/issues/browse/OFFICE-228 
So why not reopen again?
Comment 62 mbeijen 2010-04-12 20:41:17 UTC
Please re-open this issue; it is preventing proper displaying of documents on
other platforms, and as such a big obstacle for interoperability.

The copyrights issue is a non-issue if you ask me, many fonts ARE open licensed,
and also, I have not seen a request to disable picture embedding because I could
be inserting a picture on which I don't have the copyright? Please leave this to
the user.
Comment 63 tommy27 2010-04-21 07:34:22 UTC
please, repone this issue.

the copyright thing is a false obstacle
Comment 64 gleppert 2010-04-21 11:13:02 UTC
Given, how often people asked to reopen this issue, how many duplicates were
identified, and how many votes (113) are there for this issue, please reopen this.

Another question: How much demand should users in an open source project express
so that they deserve to be heard?
Comment 65 lohmaier 2010-04-22 11:26:51 UTC
reopening this issue won't help at all. 
If you want this feature, provide a patch.

If the issue would be reopened, then it would be open, but still not implemented.

Once the font-embedding made its way into the official ODF-format, then things 
are different. But until then: Don't expect the feature to be added. It is not 
like OOo not having enough other bugs to fix/other features to add.
Comment 66 gleppert 2010-04-25 21:19:07 UTC
@cloph: O.k. then let's reopen this issue. After that, we can wait for the
implementation. At least the flag "WONTFIX" would be removed. This is a first
step, at least.
Comment 67 tange 2010-04-26 09:07:49 UTC
@cloph,gleppert: I agree with both of you: Even though re-opening the issue will
not make it implemented, it will generate the some benefits:

* People will not post non-productive comments on this issue about re-opening it.
* The issue will be more visible in statistics and may encourage more people to
vote for it.
* Developers can justify working on the issue.
* It will be fair to answer: "Send in a patch or pay someone to do it".

So: Go on re-open the issue and let the issue work its way through the system as
it normally would.
Comment 68 eric.savary 2010-04-29 17:25:31 UTC
*** Issue 111260 has been marked as a duplicate of this issue. ***
Comment 69 gleppert 2010-05-24 12:09:16 UTC
Dear OpenOffice.org developers,
given the zero replies to the post by 'tange' for almost a month now, I assume
that it was not read by anyone. Please reopen this issue or provide any relevant
reason why it should not be reopened. Thank you in advance.

Comment 70 lohmaier 2010-05-24 12:13:55 UTC
OK. There you have it. A reopened issue that will get aboslutely the same 
treatment like before: None.
Comment 71 arinya 2010-06-06 07:41:54 UTC
just a reminder:
"export to pdf" will have the fonts embeded. It can be done in writer component.

So the legality issue is a false issue.
Comment 72 jcpercy 2010-07-08 04:47:59 UTC
At least implement free font and highlight them as free to save. Might encourage
all to start making free font the defacto instead of those that refuse to allow
openoffice to save.
Comment 73 lukeatbrowelldotinfo 2010-07-08 11:27:12 UTC
If you haven't already, take a look at www.fontsquirrel.com. You can easily include the fonts for which you 
have rights in your web page. You can even embed/encode them inside a CSS file.

The technical ability to embed fonts in Open Office documents is essential for any serious document 
standard going forward. 

PDF has it, DOCX has it, even the open web now has it. 

Without action, obsolescence threatens the ORACLE investment in the OpenOffice brand.
Comment 74 kpalagin 2010-07-08 12:30:23 UTC
May I suggest bringing up this topic to dev@openoffice mailing list?
No flames, no accusations, no cursewords, just short message describing why this
is necessary, competitive analisys, legal considerations, etc.
This way the issue will get attention from many more developers and we may get
some meaningfull reply.
Comment 75 Mark Lindros 2012-12-14 20:42:42 UTC
Since Apache does embedding with PDF when we export MS Office documents to PDF, wouldn't it be something trivial to achieve now that Apache runs OpenOffice and it is 2012?

Our primary publishing tools are MS Office-based, but we also have scenarios where our documents may be opened using OpenOffice and we need those fonts embedded. It really ruins the effects of our materials when the embedded font is not honored and displayed properly.
Comment 76 Mark Lindros 2012-12-14 21:29:31 UTC
My bad... got my Adobe mixed with my Apache. Obviously, Abode is the PDF company.
Comment 77 Marcus 2017-05-20 11:29:26 UTC
Reset assigne to the default "issues@openoffice.apache.org".